;
;							
;	(c) G.Shepelev		All right reserved	
;							
;
;							
;			FONT.COM			
;							
;	V 0.0			Proolix-		
;							
;

;	    Proolix		(c) 1997 G.Shepelev
;    EGA  VGA!

;     ,     ...

  IDEAL			;  TASM   IDEAL !	;-)


MACRO	JR  val	;  ,  TASM    
	jmp  short  val
   ENDM

;   Proolix

INT_NO	equ	84h

exit_vect EQU	0Ch	;   

puts	EQU	7	;   ASCIIZ  stdout   
open	EQU	24h	;  
read	EQU	26h	;     
close	EQU	28h	;  

O_RDONLY  EQU	1	;   -  


SEGMENT	seg_$	PARA	PUBLIC 'code'

  ASSUME  CS:seg_$, DS:seg_$, ES:seg_$

	ORG	100h
 

  PROC	font	FAR	;   ""  
				;  Proolix
start:				;     ...
	JR	real_start
	db	0DEh,0ADh	;  signature (magick)
 ENDP


  PROC	real_start	NEAR	;        "" !

	mov	AX,offset txt_c	;   
	push	DS		; seg 	(bug of C-compiler)
	push	AX		; offset txt
	call	_puts		;   
	add	SP,4

;    
	push	DS
	xor	AX,AX
	mov	DS,AX
	mov	AX,[485h]	; POINTS    ( 0040:0085    )
	pop	DS

	or	AH,AH		;       POINTS ?
	jz	nxt_test	;  ...

err_mode:		;      ? ;)
	mov	AX,offset txt_err_mode	;     
	JR	d_exit

nxt_test:
	cmp	AL,8	;    8   ?
	jnz	nxt0
		;   8   
	mov	DX,offset mode8
	mov	CX,2048
	JR	op_file

nxt0:	cmp	AL,14	;    14? ;)
	jnz	nxt1
		;   14   
	mov	DX,offset mode14
	mov	CX,3584
	JR	op_file


nxt1:	cmp	AL,16	;     16!
	jnz	err_mode
		;   16   
	mov	DX,offset mode16
	mov	CX,4096


op_file:		; DX -    
			; CX -  
	mov	[f_size],AL	;     

	;   
	mov	AL,O_RDONLY	;  
	push	AX		;  
	push	DS		; seg	(bug of C-compiler)
	push	DX		; offset path_name
	call	_open
	add	SP,6

	mov	[n_file],AX	;    
	inc	AX		; 0 -   
	jnz	open_ok		;  - 

d_err:			; -       :-(
	mov	AX,offset txt_derr	;     

d_exit:	push	DS		; seg	(bug of C-compiler)
	push	AX		; offset txt
	call	_puts
	add	SP,4
	jmp	[dword ptr exit_vect]	;    


open_ok:	; CX -  
	mov	BX,200h		;  
	mov	BP,offset buff	;   
	mov	SI,BP		;     
rd_file:
	xor	AX,AX
	push	AX		;    (bug of C-compiler)
	push	BX		;   ...
	push	DS		; seg (bug of C-compiler)
	push	SI		; offset	 
	push	[n_file]	;  
	call	_read	;    (bug of Proolix)
	add	SP,10

	or	DX,DX		;      = 0
	jz	nxt2	; ...

cl_d_err:		;  		:-(
	call	n_close		;       
	JR	d_err

nxt2:	cmp	AX,BX	;    ?
	jnz	cl_d_err	;     

	add	SI,BX	;    
	sub	CX,BX	;  
	jnz	rd_file		;   (bug of Proolix)

		;     
	mov	AX,1100h	;  0 -   
			; ES:BP -  
	mov	BH,[f_size]	;    
	mov	CX,256		;    
	xor	DX,DX		;    
	mov	BL,DL		;   
	int	10h		; EGA  VGA     

			;  ...
	call	n_close		;  ...
ok:	mov	AX,offset txt_ok	;     
d_e:	JR	d_exit


n_close:
	push	[n_file]	;  
	call	_close
	inc	sp
	inc	sp
	ret


_close:	mov	AX,close
	JR	f_proolix

_puts:	mov	AX,puts

f_proolix:		;       
	int	INT_NO
	ret	; ,       
		; (   )

_open:	mov	AX,open
	JR	f_proolix

_read:	mov	AX,read
	JR	f_proolix


txt_c	DB	"Font loader for EGA & VGA  Ver 0.0  (c) 1997 G.Shepelev",0
txt_err_mode	DB	"Incorrect videomode!",0
txt_derr	DB	"Disk error!",0
txt_ok	DB	"Font installed",0

mode8	DB	"08.fnt",0	;     
mode14	DB	"14.fnt",0
mode16	DB	"16.fnt",0

n_file	DW	?	;  
f_size	DB	?	;     
buff	DB	16*256 DUP (?) ;    

 ENDP
	  ENDS

	END	start
