#include <stdio.h>
#include <dos.h>
#include <struct.h>

void out_os (int c);

void outMBR (char far *buf)
{
int i;
struct MBRstru far *MBR;

MBR=(void far *)buf;

printf("System    ----Begin---- ----End-----  Preceding sec Total sec\n");
printf("          head sec  cyl head sec cyl\n");
/*     "A FAT 12  iiii  ii iiii iiii  ii iiii iiiiiiiiii    iiiiiiiiii\n" */
for (i=0;i<4;i++)
  {unsigned int j;
  if (MBR->Partition[i].indicator==0) printf(" "); else printf("A");
  printf(" ");
  out_os(MBR->Partition[i].system_indicator);
  printf(" %4i  ",MBR->Partition[i].begin_head);
  printf("%2i ",(j=MBR->Partition[i].begin_sec) & 0x3F);
  j = (j & 0xC0)<<2;
  printf("%4i ",MBR->Partition[i].begin_cyl | j);

  printf("%4i  ",MBR->Partition[i].end_head);
  printf("%2i ",(j=MBR->Partition[i].end_sec) & 0x3F);
  j = (j & 0xC0)<<2;
  printf("%4i ",MBR->Partition[i].end_cyl | j);

  printf("%10lu    ",MBR->Partition[i].preceding_sec);
  printf("%10lu\n",MBR->Partition[i].total_sec);
  }
}

int main (int argc, char *argv[])

{char buf [512];
int dev=0;
int hdd;

if (argc>1)
  switch (dev=argv[1][0])
    {
    case '0':
    case '1': dev-='0'; break;
    default: printf("usage: `vmbr 0' for view of HDD 0 partition\n\
    or `vmbr 1' for view of HDD 1 partition\n\n");
    return 1;
    }
hdd=*(char far *)MK_FP(0,0x475);
printf("\nTotal HDD devices %i\n\n",hdd);
if (hdd)
  {
  if (dev<hdd)
    {
    printf("Partition table of HDD %i\n\n",dev);
    absread(0x80+dev,1,0,buf);
    outMBR(buf);
    }
  }
return 0;
}
