#include <stdio.h>

#include "..\include\limits.h"
#include "..\include\struct.h"

void ViewEXE (struct exe_header far *Buf)
{long i, j;
printf("Bytes on last page %04X\n",Buf->PartPag );
printf("Pages in file %04X\n",Buf->PageCnt );
printf("Relocations %04X\n",Buf->ReloCnt );
printf("Paragraphe in header %04X\n",Buf->HdrSize );
printf("MinMem %04X par\n",Buf->MinMem  );
printf("MaxMem %04X par\n",Buf->MaxMem  );
printf("SS:SP %04X:%04X\n",Buf->ReloSS,Buf->ExeSP);
printf("CheckSum %04X\n",Buf->ChkSum  );
printf("CS:IP %04X:%04X\n",Buf->ReloCS,Buf->ExeIP);
printf("Relocation table addr %04X\n",Buf->TablOff );
/* printf("Overlay No. %1X\n",Buf->Overlay); */
}
/*  [TECH Help!]


                           EXE                       


.   
  
            
 +0      2  4Dh 5aH ""  .EXE ('MZ')
            
 +2      2  PartPag     ( )
            
 +4      2  PageCnt    512- ,  
            
 +6      2  ReloCnt     
            
 +8      2  HdrSize    16- 
            
+0aH     2  MinMem        ()
            
+0cH     2  MaxMem        ()
            
+0eH     2  ReloSS      (  SS)
            
+10H     2  ExeSP     SP ( )  
            
+12H     2  ChkSum    (     )
            
+14H     2  ExeIP     IP ( )  
            
+16H     2  ReloCS      (  CS)
            
+18H     2  TablOff    1-   ( 001cH)
            
+1aH     2  Overlay   (0   )
            
1cH             EXE
                 . 
+ ?     4*?  .  ԁ   .  ԁ   [EXE+18H]. 
                [EXE+6] 4- .
+ ?     ?      
+ ?     ?     

 EXE-      ,   -
  (FAR CALL,  ,   MOV AX,data_seg) 
    ,  .   ,
   DOS ( 4bH )    EXE:

1.   PSP   DOS 26H

2.   1cH   EXE (   EXE)
       

3.     = ( (PageCnt*512)-(HdrSize*16) ) - PartPag

4.       = (HdrSize * 16)

5.    , START_SEG,   (  PSP + 10H)

6.      ,    START_SEG:0000

7.  LSEEK (.  )     (TablOff)

8.      (ReloCnt):
    a.     16-  (I_OFF,I_SEG)
    b.  RELO_SEG=(START_SEG+I_SEG) (  )
    c.     RELO_SEG:I_OFF (  )
    d.  START_SEG    (  )
    e.       (RELO_SEG:I_OFF)

9.       MaxMem  MinMem

10.     :
    a. ES = DS = PSP
    b. AX =       
    c. SS = START_SEG+ReloSS, SP = ExeSP
    d. CS = START_SEG+ReloCS, IP = ExeIP
    (: PUSH seg; PUSH offset; RETF)
 */
